Dataset API Reference

Project, batches and annotation management service

Annotations

Annotations capture labeled data or markups on entries,
supporting both JSON:API and JSON-RPC interfaces for flexible batch operations.

post /annotations/_rpc - __jsonrpc_handler__

Description

JSON-RPC API endpoint

Request Body

Response

200

Successful response

get /annotations/{resource_id} - show

Description

Show a specific dataset:annotations

Parameters

Name In Type Required Description
resource_id path string Required -
included query array Optional -
fields query string Optional -

Response

200

Successful response

patch /annotations/{resource_id} - update

Description

Update a dataset:annotations

Parameters

Name In Type Required Description
resource_id path string Required -

Request Body

Response

200

Successful response

delete /annotations/{resource_id} - delete

Description

Delete the dataset:annotations

Parameters

Name In Type Required Description
resource_id path string Required -

Response

204

No content

get /annotations - index

Description

Return a paginated list of dataset:annotations

Parameters

Name In Type Required Description
page[number] query integer Optional

The page number, default to 1

page[size] query integer Optional

The number of items per page, default to 1000

sort query string Optional

The sort order, comma separated list of fields. See sorting section for more details

count query boolean Optional

Set to true to return the total number of items in the collection

filter[id] query any Optional -
filter[project_id] query any Optional -
filter[dataset_id] query any Optional -
filter[entry_id] query any Optional -
filter[dimensions] query any Optional -
filter[annotation] query any Optional -
filter[metadata] query any Optional -
filter[created_by_email] query any Optional -
filter[created_at] query any Optional -
filter[updated_at] query any Optional -
fields query string Optional

The fields to include in the response.
The key is the resource type and the value is an array of fields.

Response

200

Successful response

post /annotations - create

Description

Create a new dataset:annotations

Request Body

Response

200

Successful response

Datasets

Datasets contain collections of entries (data items) for annotation within a project.

get /datasets - index

Description

Return a paginated list of dataset:datasets

Parameters

Name In Type Required Description
page[number] query integer Optional

The page number, default to 1

page[size] query integer Optional

The number of items per page, default to 1000

sort query string Optional

The sort order, comma separated list of fields. See sorting section for more details

count query boolean Optional

Set to true to return the total number of items in the collection

filter[id] query any Optional -
filter[project_id] query any Optional -
filter[name] query any Optional -
filter[labels] query any Optional -
filter[modality] query any Optional -
filter[labeling_configuration] query any Optional -
filter[workflow_configuration] query any Optional -
filter[status] query any Optional -
filter[progress] query any Optional -
filter[entries_total_count] query any Optional -
filter[entries_completed_count] query any Optional -
filter[entries_in_progress_count] query any Optional -
filter[created_at] query any Optional -
filter[updated_at] query any Optional -
filter[name__match] query any Optional -
filter[status__in] query any Optional -
filter[progress__gte] query any Optional -
filter[progress__lte] query any Optional -
filter[project_id__eq] query any Optional -
filter[modality__in] query any Optional -
filter[created_at__gte] query any Optional -
filter[created_at__lte] query any Optional -
filter[updated_at__gte] query any Optional -
filter[updated_at__lte] query any Optional -
included query array Optional

The related resources to include in the response. Allowed resources are:

  • entries
  • project
fields query string Optional

The fields to include in the response.
The key is the resource type and the value is an array of fields.

Response

200

Successful response

post /datasets - create

Description

Create a new dataset:datasets

Request Body

Response

200

Successful response

get /datasets/{resource_id} - show

Description

Show a specific dataset:datasets

Parameters

Name In Type Required Description
resource_id path string Required -
included query array Optional -
fields query string Optional -

Response

200

Successful response

patch /datasets/{resource_id} - update

Description

Update a dataset:datasets

Parameters

Name In Type Required Description
resource_id path string Required -

Request Body

Response

200

Successful response

delete /datasets/{resource_id} - delete

Description

Delete the dataset:datasets

Parameters

Name In Type Required Description
resource_id path string Required -

Response

204

No content

Entries

Entries represent individual data items within a dataset
that can be assigned, annotated, and tracked through workflow stages.

get /entries/{resource_id} - show

Description

Show a specific dataset:entries

Parameters

Name In Type Required Description
resource_id path string Required -
included query array Optional -
fields query string Optional -

Response

200

Successful response

patch /entries/{resource_id} - update

Description

Update a dataset:entries

Parameters

Name In Type Required Description
resource_id path string Required -

Request Body

Response

200

Successful response

delete /entries/{resource_id} - delete

Description

Delete the dataset:entries

Parameters

Name In Type Required Description
resource_id path string Required -

Response

204

No content

get /entries - index

Description

Return a paginated list of dataset:entries

Parameters

Name In Type Required Description
page[number] query integer Optional

The page number, default to 1

page[size] query integer Optional

The number of items per page, default to 1000

sort query string Optional

The sort order, comma separated list of fields. See sorting section for more details

count query boolean Optional

Set to true to return the total number of items in the collection

filter[id] query any Optional -
filter[project_id] query any Optional -
filter[dataset_id] query any Optional -
filter[priority] query any Optional -
filter[wf_step] query any Optional -
filter[status] query any Optional -
filter[job_id] query any Optional -
filter[resource] query any Optional -
filter[assigned_to_id] query any Optional -
filter[submitted_by_id] query any Optional -
filter[reviewed_by_id] query any Optional -
filter[created_at] query any Optional -
filter[updated_at] query any Optional -
filter[resource__match] query any Optional -
filter[status__in] query any Optional -
filter[priority__in] query any Optional -
filter[assigned_to_id] query any Optional -
filter[assigned_to_id__eq] query any Optional -
filter[assigned_to_id__in] query any Optional -
filter[wf_step__in] query any Optional -
filter[participated] query any Optional -
included query array Optional

The related resources to include in the response. Allowed resources are:

  • dataset
  • dataset.project
  • assigned_to
  • submitted_by
  • reviewed_by
fields query string Optional

The fields to include in the response.
The key is the resource type and the value is an array of fields.

Response

200

Successful response

post /entries - create

Description

Create a new dataset:entries

Request Body

Response

200

Successful response

patch /entries/{id}/assign - assign

Description

Assign a project member to an entry

Parameters

Name In Type Required Description
id path string Required -

Request Body

Response

200

Successful response

get /entries/{id}/select - select

Description

Select workflow event for an entry

Parameters

Name In Type Required Description
id path string Required -

Response

200

Successful response

post /entries/{id}/submit - submit

Description

Submit workflow event for an entry

Parameters

Name In Type Required Description
id path string Required -

Request Body

Response

200

Successful response

post /entries/{id}/error - error

Description

Trigger error event for an entry

Parameters

Name In Type Required Description
id path string Required -

Request Body

Response

200

Successful response

Note Comments

Comments provide threaded discussions within note feeds
for collaborative communication on entries and annotations.

get /note_comments/{resource_id} - show

Description

Show a specific dataset:note_comments

Parameters

Name In Type Required Description
resource_id path string Required -
included query array Optional -
fields query string Optional -

Response

200

Successful response

patch /note_comments/{resource_id} - update

Description

Update a dataset:note_comments

Parameters

Name In Type Required Description
resource_id path string Required -

Request Body

Response

200

Successful response

delete /note_comments/{resource_id} - delete

Description

Delete the dataset:note_comments

Parameters

Name In Type Required Description
resource_id path string Required -

Response

204

No content

get /note_comments - index

Description

Return a paginated list of dataset:note_comments

Parameters

Name In Type Required Description
page[number] query integer Optional

The page number, default to 1

page[size] query integer Optional

The number of items per page, default to 1000

sort query string Optional

The sort order, comma separated list of fields. See sorting section for more details

count query boolean Optional

Set to true to return the total number of items in the collection

filter[id] query any Optional -
filter[note_feed_id] query any Optional -
filter[content_md] query any Optional -
filter[created_by_email] query any Optional -
filter[created_at] query any Optional -
filter[updated_at] query any Optional -
filter[edited_at] query any Optional -
filter[created_by_email__match] query any Optional -
filter[created_at__gte] query any Optional -
filter[created_at__lte] query any Optional -
filter[updated_at__gte] query any Optional -
filter[updated_at__lte] query any Optional -
included query array Optional

The related resources to include in the response. Allowed resources are:

  • note_feed
fields query string Optional

The fields to include in the response.
The key is the resource type and the value is an array of fields.

Response

200

Successful response

post /note_comments - create

Description

Create a new dataset:note_comments

Request Body

Response

200

Successful response

Note Feeds

Note feeds enable team discussions and issue tracking
on entries or annotations, supporting pending and resolved statuses.

get /note_feeds/{resource_id} - show

Description

Show a specific dataset:note_feeds

Parameters

Name In Type Required Description
resource_id path string Required -
included query array Optional -
fields query string Optional -

Response

200

Successful response

patch /note_feeds/{resource_id} - update

Description

Update a dataset:note_feeds

Parameters

Name In Type Required Description
resource_id path string Required -

Request Body

Response

200

Successful response

delete /note_feeds/{resource_id} - delete

Description

Delete the dataset:note_feeds

Parameters

Name In Type Required Description
resource_id path string Required -

Response

204

No content

get /note_feeds - index

Description

Return a paginated list of dataset:note_feeds

Parameters

Name In Type Required Description
page[number] query integer Optional

The page number, default to 1

page[size] query integer Optional

The number of items per page, default to 1000

sort query string Optional

The sort order, comma separated list of fields. See sorting section for more details

count query boolean Optional

Set to true to return the total number of items in the collection

filter[id] query any Optional -
filter[project_id] query any Optional -
filter[dataset_id] query any Optional -
filter[entry_id] query any Optional -
filter[annotation_id] query any Optional -
filter[created_by_email] query any Optional -
filter[anchor_type] query any Optional -
filter[position] query any Optional -
filter[status] query any Optional -
filter[content_md] query any Optional -
filter[created_at] query any Optional -
filter[updated_at] query any Optional -
filter[edited_at] query any Optional -
filter[status__in] query any Optional -
filter[created_by_email__match] query any Optional -
filter[created_at__gte] query any Optional -
filter[created_at__lte] query any Optional -
filter[updated_at__gte] query any Optional -
filter[updated_at__lte] query any Optional -
included query array Optional

The related resources to include in the response. Allowed resources are:

  • entry
  • annotation
  • note_comments
fields query string Optional

The fields to include in the response.
The key is the resource type and the value is an array of fields.

Response

200

Successful response

post /note_feeds - create

Description

Create a new note feed
This endpoint creates a new note feed for an entry.
When anchor_type is "annotation", annotation_id is required.

Request Body

Response

204

No content

post /note_feeds/{id}/resolve - resolve

Description

Resolve a note feed by updating status from pending to resolved

Parameters

Name In Type Required Description
id path string Required -

Request Body

Response

200

Successful response

Project Members

Members are user accounts assigned to projects
with specific roles for annotation and review work.

get /project_members - index

Description

Return a paginated list of dataset:project_members

Parameters

Name In Type Required Description
page[number] query integer Optional

The page number, default to 1

page[size] query integer Optional

The number of items per page, default to 1000

sort query string Optional

The sort order, comma separated list of fields. See sorting section for more details

count query boolean Optional

Set to true to return the total number of items in the collection

filter[id] query any Optional -
filter[project_id] query any Optional -
filter[account_id] query any Optional -
filter[name] query any Optional -
filter[email] query any Optional -
filter[role] query any Optional -
filter[invited_by_id] query any Optional -
filter[disabled_at] query any Optional -
filter[created_at] query any Optional -
filter[updated_at] query any Optional -
filter[email__match] query any Optional -
filter[project_id] query any Optional -
filter[account_id] query any Optional -
filter[role__in] query any Optional -
filter[created_at__gte] query any Optional -
filter[created_at__lte] query any Optional -
filter[organization_id__in] query any Optional -
filter[enabled] query any Optional -
included query array Optional

The related resources to include in the response. Allowed resources are:

  • project
fields query string Optional

The fields to include in the response.
The key is the resource type and the value is an array of fields.

Response

200

Successful response

post /project_members - create

Description

Create a new dataset:project_members

Request Body

Response

200

Successful response

get /project_members/{resource_id} - show

Description

Show a specific dataset:project_members

Parameters

Name In Type Required Description
resource_id path string Required -
included query array Optional -
fields query string Optional -

Response

200

Successful response

patch /project_members/{resource_id} - update

Description

Update a dataset:project_members

Parameters

Name In Type Required Description
resource_id path string Required -

Request Body

Response

200

Successful response

delete /project_members/{resource_id} - delete

Description

Delete the dataset:project_members

Parameters

Name In Type Required Description
resource_id path string Required -

Response

204

No content

Projects

Projects organize datasets and team members
for collaborative data annotation work.

get /projects/{resource_id} - show

Description

Show a specific dataset:projects

Parameters

Name In Type Required Description
resource_id path string Required -
included query array Optional -
fields query string Optional -

Response

200

Successful response

patch /projects/{resource_id} - update

Description

Update a dataset:projects

Parameters

Name In Type Required Description
resource_id path string Required -

Request Body

Response

200

Successful response

delete /projects/{resource_id} - delete

Description

Delete the dataset:projects

Parameters

Name In Type Required Description
resource_id path string Required -

Response

204

No content

get /projects - index

Description

Return a paginated list of dataset:projects

Parameters

Name In Type Required Description
page[number] query integer Optional

The page number, default to 1

page[size] query integer Optional

The number of items per page, default to 1000

sort query string Optional

The sort order, comma separated list of fields. See sorting section for more details

count query boolean Optional

Set to true to return the total number of items in the collection

filter[id] query any Optional -
filter[name] query any Optional -
filter[description] query any Optional -
filter[created_by_email] query any Optional -
filter[created_at] query any Optional -
filter[updated_at] query any Optional -
filter[organization_id] query any Optional -
filter[created_by_email__match] query any Optional -
filter[created_at__gte] query any Optional -
filter[created_at__lte] query any Optional -
filter[organization_id] query any Optional -
filter[organization_id__in] query any Optional -
filter[updated_at__gte] query any Optional -
filter[updated_at__lte] query any Optional -
fields query string Optional

The fields to include in the response.
The key is the resource type and the value is an array of fields.

Response

200

Successful response

post /projects - create

Description

Create a new dataset:projects

Request Body

Response

200

Successful response